---

- hosts: localhost
  tasks:
    - name: "Logon to CyberArk Vault"
      cyberark_authentication:
        api_base_url: "https://{{ pvwa_url }}"
        validate_certs: yes
        username: "{{ epv_user }}"
        password: "{{ epv_password }}"

    - name: "Fetch {{ instance_username + '@' + instance_ip }} account from Cyberark Vault"
      uri:
        url: "https://{{ pvwa_url }}/PasswordVault/api/Accounts?limit=1&searchType=StartsWith&search={{ (instance_username + ' ' + instance_ip) | urlencode }}"
        method: GET
        validate_certs: yes
        return_content: yes
        headers:
          Authorization: "{{ cyberark_session.token }}"
        status_code: 200
      register: account

    - name: "Download {{ instance_username + '@' + instance_ip }} ssh key from Cyberark Vault"
      uri:
        url: "https://{{ pvwa_url }}/PasswordVault/api/Accounts/{{ account.json.value[0].id }}/Password/Retrieve"
        method: POST
        validate_certs: yes
        return_content: yes
        headers:
          Authorization: "{{ cyberark_session.token }}"
        body_format: json
        body:
          Reason: "Create logon and reconcile accounts for {{ instance_ip }}"
        status_code: 200
      register: key
      no_log: yes

    - name: "Logoff from CyberArk Vault"
      cyberark_authentication:
        state: absent
        cyberark_session: "{{ cyberark_session }}"

    - name: "Create a temporary file for ssh key"
      tempfile:
        state: file
        suffix: key
      register: temp_key
      no_log: yes

    - name: "Write ssh key to temporary file"
      copy:
        dest: "{{ temp_key.path }}"
        content: "{{ key.content | regex_replace('\"', '') }}"
      no_log: yes

    - name: "Add {{ instance_ip }} to inventory as target"
      add_host:
        name: target
        ansible_ssh_user: "{{ instance_username }}"
        ansible_ssh_host: "{{ instance_ip }}"
        ansible_ssh_private_key_file: "{{ temp_key.path }}"

- hosts: target
  become: yes
  become_user: root
  tasks:
    - include_role:
        name: ansible_linux_onboarder_role

- hosts: localhost
  tasks:
    - name: "Remove temporary ssh key file"
      ansible.builtin.file:
        path: "{{ temp_key.path }}"
        state: absent